//
//  Copyright (C) by S.Tomabechi 1993
//  All rithts reserved.
//
//  Ԃv
//
//  1996/10 Windows95 pɏC.
//
//  ygz
//    CPUTime cputime ;
//    cputime.Start() ;
//       do something ;
//    cputime.Stop() ;
//    cputime.Start() ;
//       do other thing ;
//    cputime.Stop() ;     pԂ͉ZD
//    cputime.Reset() ;    pԂ 0 ɂ
//
#ifndef __CPUTIME_HPP
#define __CPUTIME_HPP

//#include <Windows.h>
#include <iostream.h>
#include <time.h>
#ifndef WIN32 
inline long GetTickCount() { return time(NULL)*1000 ; }
#endif

class CPUTime
{
  friend istream& operator>>(istream& is,CPUTime& cputime) ;
public:
  CPUTime(void) { Duration=0 ; }
  void Start(void) ;
  void Stop(void)  ;
//  void Start(void) { StartTime=GetTickCount(); }
//  void Stop(void)  { Duration+=(GetTickCount()-StartTime) ; }
  void Reset(void) { Duration=0 ; }
  double Time() { return double(Duration)/1000 ; }
  long hour(void) { return long(Time()/3600) ; }
  long second(void) { return long(Time()-long(Time()/60)*60) ; }
  long minutes(void) { return long(Time()-hour()*3600)/60 ; }
  long hundredths(void) { return long(100*(Time()-long(Time()))) ; }
private:
  long StartTime ;            // Start 
  long Duration ;             // p
} ;

ostream& operator<<(ostream& os,CPUTime& cputime) ;
istream& operator>>(istream& is,CPUTime& cputime) ;
#endif
