//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  conversion from Mint to double
//  long double ւ̌^ϊ
//
#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "LDbl.hpp"
#include "Dbl.hpp"
#include "IntFuncs.hpp"

#ifdef __BORLANDC__
//#if 0
Mint::operator long double() const
{

  LDbl d(0) ;
  unsigned long n,p ;
  long k,l ;

  k=nDigit-1 ;

  if( k<0 ) return d ;      // zero

  l=ilog2(digit[k])+1 ;



  n=(digit[k])<<(32-l) ;

  if( k>0 && l<32 ) p=digit[k-1]>>l ;
  else p=0 ;
  n+=p ;
  d.SetHigh(n) ;

  if( k>0 ) n=(digit[k-1])<<(32-l) ;
  else n=0 ;

  if( k>1 && l<32 ) p=(digit[k-2])>>l ;
  else p=0 ;

  n+=p ;
  d.SetLow(n) ;

//  d.SetSign(this->Sign) ;
  d.SetSign(sign(*this)) ;
  d.SetExp(k*NBITS+l-1) ;
//cout << endl << " long double "<< (long double)d ;
  return d ;

}

#endif           // VC++ V4.0 ł long double = double

Mint::operator double() const
{

  Dbl d(0) ;

  long n,p ;
  long k,l ;

  k=nDigit-1 ;

  if( k<0 ) return d ;

  l=ilog2(digit[k]) ;

//  if( k<=0 && l<0 ) return d ;  // 0 ɈႢȂ


//  if( l==0 ) k-- ;
//  cout << endl << "enter double " << k ;

  if( k>=0 ) n=((digit[k])<<(32-l)) ;
  else return 1 ;

  if( k>0 && l<32 ) p=digit[k-1]>>l ;   // l=32 ̂ƂłȂ
  else p=0 ;
  n += p ;
  d.SetHigh(n) ;

  if( k>0 ) n=(digit[k-1])<<(32-l) ;
  else n=0 ;

  if( k>1 && l<32 ) p=(digit[k-2])>>l ;
  else p=0 ;

  n+=p ;
  d.SetLow(n) ;

  d.SetSign(sign(*this)) ;
  d.SetExp(k*NBITS+l) ;
//cout << endl << " double " << (double)d ;
  return d ;

}


