//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  compute cyclotomic number 
//
//  deg :degree  x^deg-1=\prod \phi_n(x) 
//  x   variable 
//
#include "Mint.hpp"
#include "MintFunc.hpp"

Mint cyc_num(unsigned long d,long x)
{
  Mint c ;
  unsigned long q ;
  c=1 ;
  for( q=1 ; q<d  ; q++ ) ++(c*=x) ;    // c <- c*x+1

  for( q=2 ; q<d ; q++ ) {
    if( d%q==0 ) c/=cyc_num(q,x) ;      // divide by cyclotomic number with smaller degree
  }
  return c ;
}

