//
//  Copyright (C) by S.Tomabechi 1993,1995
//  All rights reserved.
//
//  divide complex number by complex number 
//
#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Complex.hpp"

Complex& Complex::isDiv(const Complex& a,const Complex& b)
{
  Fint r,d,_t ;
  if( abs(real(b))<=abs(imag(b)) ) {
    if( imag(b)==0 ) {
      re.isDivF(real(a),real(b)) ;
      im.isDivF(imag(a),real(b)) ;
    }
    else {
                                
      r.isDivF(real(b),imag(b)) ;
      d=imag(b)+r*real(b) ;     // d=(1+r^2)*imag(c)=imag(c)+real(c)^2/imag(c)

      _t=real(a) ;              // =c*(r-i)
      re=(real(a)*r+imag(a))/d ; // 1/c=(r-i)/d
      im=(imag(a)*r-_t)/d ;
    }
  }
  else {
    if( real(b)==0 ) {           //  c is purely imaginary 
      re.isDivF(real(a),imag(b)) ;
      im.isDivF(imag(a),imag(b)) ;
      ~re ;
      Swap(re,im) ;
    }
    else {
      r=imag(b)/real(b) ;        // c=real(c)(1+ri) ;
      d=real(b)+r*imag(b) ;      // d=(1+r^2)*real(c)=real(c)+imag(c)^2/real(c)
      _t=real(a) ;               // =c*(1-ri) ;
      re=(real(a)+r*imag(a))/d ; // 1/c=(1-ri)/d
      im=(imag(a)-r*_t)/d ;
    }
  }

  return *this ;
}

