//
//  Cioyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  gEuclid ݏ@ (Pxp)
//

//
// gcd(u,v)=u*u1+v*u2
//
#ifdef __BORLANDC__
#pragma inline
#endif

long egcd(const long u,const long v,long& u1,long& u2)
{
  long u3(u) ;
  long v1(0),v3(v) ;

  __asm {

    mov   esi,u1
    mov   edi,u2

    mov   dword ptr [esi],1   // u1=1
    mov   dword ptr [edi],0   // u2=0
  }
LOOP_EUCLID:
  __asm {
    cmp   v3,0
    je    RET1
    mov   eax,u3    // divide(u3,v3,q,r)
    cdq
    idiv  v3
    mov   ecx,eax             //ecx=q
    xchg  edx,v3              // v3<->r
    mov   u3,edx              // u3=r

    mov   eax,v1
    mul   ecx
    mov   ebx,[esi] // u-q*v1
    sub   ebx,eax
    xchg  ebx,v1
    mov   [esi],ebx
    jmp   LOOP_EUCLID
  }
RET1:
  __asm {
    mov   eax,u
    mul   dword ptr [esi]
    mov   ebx,u3
    sub   ebx,eax
    mov   eax,ebx
    cdq
    idiv  v
    mov   [edi],eax // u2=(d-a*u1)/v

  }
  return u3 ;

}
