//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  get real number from stream
//
//  ̓
//
#define _ONLY_FINTDECL_
#include "Fint.hpp"
#include <ctype.h>
istream& operator>>(istream& is,Fint& a)
{
  int ch ;
  unsigned long dec(10) ;
  signed char sign,sign0=1 ;
  int iTerminate=0 ;
  int j ;
  Mint z(0) ;

  a=0 ;
Try_more:
  do {                       // AA_ȊOǂ݂Ƃ΂
    ch=is.get() ;
    if( ch=='\n' ) goto Try_more ;
    else if( ch==EOF ) return is ;
    else if( ch=='/' ) {
      ch=is.get() ;
      if( ch!='/' ) continue ;
      else while( ch!='\n' ) ch=is.get() ; // ȉ̓RgƔF
    }
  } while( !isdigit(ch) && ch != '.' && ch != '+' && ch != '-' ) ;
  is.putback((char)ch) ;

  do {                      // read integer part
    ch=is.get() ;           // 𒊏o
    switch( ch ) {
      case '0' : case '1' : case '2' : case '3' : case '4' :
      case '5' : case '6' : case '7' : case '8' : case '9' :
        z*=dec ;
        z+=ch-'0' ;
        break ;
      case '-' :
        sign0=-sign0 ;
        break ;
      case '+' :               // read off
        break ;
      case '.' : case 'e' : case 'E' :
        is.putback((char)ch) ;
        ch=EOF ;
        break ;
      case '\n' : case EOF:
      default :
        iTerminate=1 ;
        ch=EOF ;
        break ;
    }

  } while( ch!=EOF ) ;

  z.nDim&=_POSITIVE_ ;
  if( iTerminate ) {                // ̂
    a=z ;
    (a.nDim&=_DIGITS_)|=((unsigned long)sign0)<<24 ;
    return is ;
  }

  Mint f(0) ;
  long k=0,l ;

  ch=is.get() ;

  if( ch=='.' ) {             // read fractional part
    iTerminate=0 ;            // 𒊏o
    do {
      ch=is.get() ;
      switch( ch ) {
        case '0' : case '1' : case '2' : case '3' : case '4' :
        case '5' : case '6' : case '7' : case '8' : case '9' :
          f*=dec ;
          f+=ch-'0' ;
          k++ ;
          break ;
        case 'e' : case 'E' :    // _\
          is.putback((char)ch) ;
          ch=EOF ;
          break ;
        default :
          iTerminate=1 ;
          ch=EOF ;
          break ;
      }

    } while( ch!=EOF ) ;

    l=long(double(k)/(4*2.408242)+1) ;         // Œ菬_\
    a=f ;
    if( l>a.fDigit ) a[l-a.fDigit] ;
    for( j=0 ; j<k ; j++ ) a/=dec ;
    a+=z ;
    (a.nDim&=_DIGITS_)|=((unsigned long)sign0)<<24 ;
    if( iTerminate ) return is ;
  }
  else {
    is.putback((char)ch) ;
    a=z ;
    (a.nDim&=_DIGITS_)|=((unsigned long)sign0)<<24 ;
  }  // ̂

  ch=is.get() ;
  if( ch=='e' || ch=='E' ) {     // floating point case
    int ipower=0 ;
    sign=1 ;
    do {                         // pwo
      ch=is.get() ;
      switch( ch ) {
        case '0' : case '1' : case '2' : case '3' : case '4' :
        case '5' : case '6' : case '7' : case '8' : case '9' :
          ipower *= dec ;
          ipower += ch-'0' ;
          break ;
        case '-' :
          sign=-sign ;
          break ;
        case '+' :
          break ;
        default :
          ch=EOF ;   // ̑̕I
        break ;
      }

    } while( ch != EOF ) ;

    ipower*=sign ;            // multiply 10^n
    if( ipower<0 ) {
      a[int((-ipower)/(4*2.408242))] ;
      for( j=0 ; j<-ipower ; j++ ) a/=dec ;
    }
    else {
      for( j=0 ; j<ipower ; j++ ) a*=dec ;
    }
    return is ;
  }

  return is ;

}

