//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//     All rights reserved
//
//  Fixed point integer class Ver 2.40
//
//  Œ菬_NX Ver 2.40
//
//
#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif

#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Fint.hpp"
#ifdef WIN32
#include <strstrea.h>
#else
#include <strstream.h>
#endif

extern "C"
{
  long double ceill(long double d) ;
}

//
//  set default precision
//
// ftHg̐xݒ
//  ߂l : ȑO̐x
//
int SetPrecision(const int _precision)
{
  int prec(Mint::Precision) ;
  Mint::Precision=_precision>1 ? _precision:1 ;  // Œ̐x 1 Ƃ

  Fint::_Ftemp.fDigit=Mint::Precision ;
  Fint::_uFtemp.fDigit=Mint::Precision ;
  Fint::_vFtemp.fDigit=Mint::Precision ;

  return prec ;
}


//
//  constructors
//
Fint::Fint()
{
  ((Mint*)(this))->allocate(Precision+1) ;
  nDigit=0 ;
  fDigit=Precision ;
}

// size  : number of total digits
// fsize : number of fractional digits
//
// size  Ŝ̌
// fsize ̌
Fint::Fint(int size,int fsize):Mint(size,fsize)
{
}

Fint::Fint(const int n)
{
  allocate(Precision+1,Precision) ;
  *this=n ;
}

Fint::Fint(const long n)
{
  allocate(Precision+1,Precision) ;
  *this=n ;
}

Fint::Fint(const unsigned long n)
{
  allocate(Precision+1,Precision) ;
  *this=n ;
}

Fint::Fint(const double& d)
{
  int size=2>Precision ? 2:Precision ;
  allocate(size+1,size) ;
  *this=d ;
}

Fint::Fint(const long double& d)
{
  int size=2>Precision ? 2:Precision ;
  allocate(size+1,size) ;
  *this=d ;
}

Fint::Fint(const Mint& n)
{
  allocate(n.ndigit()+Precision,Precision) ;
  *this=n ;
}

Fint& Fint::operator=(const char Number[])
{
  strstream buffer ;
  buffer << Number ;
  buffer >> *this ;
  return *this ;
}
