%include "mint.inc"
[BITS 32]
	extrn	@$bdla$qpv
	extrn	@Mint@$bctr$qii
	extrn	@Mint@isAdd$qrx4Mintt1
	extrn	@Mint@isSub$qrx4Mintt1
	extrn	@Mint@isMul$qrx4Mintt1
	extrn	@Mint@isShift32$qrx4Mintxl
	public	@Mint@isSquare$qrx4Mint
	extrn	@Mint@Square_digit
	extrn	@Mint@FFT_digit
	extrn	@Swap$qr4Mintt1
[SECTION .text]	
@Mint@isSquare$qrx4Mint
   ;	
   ;	Mint& MintisSquare(const Mint& a)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-64
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	a.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	
   ;	  int anDigit(a.nDigit) ;
   ;	
@1
	mov       eax,dword ptr [ebp+12]
	mov       edx,dword ptr [eax+4]
	mov       dword ptr [ebp-4],edx
   ;	
   ;	
   ;	  if( a.nDigit==0 ) {       // a==0 ?
   ;	
	mov       ecx,dword ptr [ebp+12]
	mov       eax,dword ptr [ecx+4]
	test      eax,eax
	jne       short @2
   ;	
   ;	    nDigit=0 ;
   ;	
	mov       edx,dword ptr [ebp+8]
	xor       ecx,ecx
	mov       dword ptr [edx+4],ecx
   ;	
   ;	    nDim&=_POSITIVE_ ;      // signature <- 1
   ;	
	mov       eax,dword ptr [ebp+8]
	and       dword ptr [eax+12],33554431
   ;	
   ;	    return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
	jmp       @3
   ;	
   ;	  }
   ;	
   ;	
   ;	  //
   ;	  // a=a2*t+a1        t=(2^32)^n
   ;	  // a^2=a2^2*t^2+((a2+a1)^2-a2^2-a1^2)*t+a1^2
   ;	  //
   ;	
   ;	  if( anDigit>Square_digit ) {
   ;	
@2
	mov       edx,dword ptr [ebp-4]
	mov       ecx,dword ptr [@Mint@Square_digit]
	cmp       edx,ecx
;	jle       @5
	je 		@99_5
	jmp		@5
@99_5
   ;	
   ;	    if( anDigit>FFT_digit ) return isMul(a,a) ; // give job to FFT
   ;	
@4
	mov       eax,dword ptr [ebp-4]
	mov       edx,dword ptr [@Mint@FFT_digit]
	cmp       eax,edx
	jle       short @6
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+8]
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
	jmp       @3
   ;	
   ;	    int n(anDigit+1) ;
   ;	
@6
@7
	mov       ecx,dword ptr [ebp-4]
   ;	
   ;	    Mint s2(n,0) ;
   ;	
	lea       eax, [ebp-32]
	inc       ecx
	mov       dword ptr [ebp-8],ecx
	push      dword 0
	push      dword ptr [ebp-8]
	push      eax
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	    Mint s1(n,0) ;                // a=s2*b+s1   bradix
   ;	
	lea       edx,[ebp-48]
	push      dword 0
	push      dword ptr [ebp-8]
	push      edx
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	    Mint ab(n,0) ;                // ab= a+b
   ;	
	lea       ecx,[ebp-64]
	push      dword 0
	push      dword ptr [ebp-8]
	push      ecx
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	    n>>=1 ;
   ;	
	sar       dword ptr [ebp-8],1
   ;	
   ;	    __asm {                  // exact length of a1
   ;	      mov  esi,a
   ;	
	mov	  esi,dword ptr [ebp+12]
   ;	
   ;	      mov  ebx,n
   ;	
	mov	  ebx,dword ptr [ebp-8]
   ;	
   ;	#ifdef __BCC__
   ;	      mov  edi,dword ptr [esi].digit
   ;	#else
   ;	      mov  edi,dword ptr [esi+DIGIT]
   ;	
	mov	  edi,dword ptr [esi+0]
   ;	
   ;	#endif
   ;	     }
   ;	SearchZero1
   ;	    __asm {
   ;	      cmp  dword ptr [ebx*NBYTE+edi+-NBYTE],0
   ;	
@8
	cmp	  dword ptr [ebx*(4)+edi+-(4)],0
   ;	
   ;	      jne  FindNonZero1
   ;	
	jne       short @9
   ;	
   ;	      dec  ebx
   ;	
	dec	  ebx
   ;	
   ;	      jnz  SearchZero1
   ;	
	jne       short @8
   ;	
   ;	    }
   ;	FindNonZero1
   ;	    __asm {
   ;	#ifdef __BCC__
   ;	      mov  dword ptr [esi].nDigit,ebx
   ;	#else
   ;	      mov  dword ptr [esi+NDIGIT],ebx
   ;	
@9
	mov	  dword ptr [esi+4],ebx
   ;	
   ;	#endif
   ;	      mov   edi,dword ptr [s2].digit
   ;	
	mov	   edi,dword ptr [ebp-32+0]
   ;	
   ;	#ifdef __BCC__
   ;	      mov   bl,byte ptr [esi].nDim[3]
   ;	      mov   byte ptr [s2].nDim[3],bl
   ;	      mov   esi,dword ptr [esi].digit    // 98/01/11
   ;	#else
   ;	      mov   bl,byte ptr [esi+SIGN]
   ;	
	mov	   bl,byte ptr [esi+15]
   ;	
   ;	      mov   byte ptr [s2+SIGN],bl
   ;	
	mov	   byte ptr [ebp-32+15],bl
   ;	
   ;	      mov   esi,dword ptr [esi+DIGIT]    // 98/01/11
   ;	
	mov	   esi,dword ptr [esi+0]    
   ;	
   ;	#endif
   ;	      mov   ebx,n
   ;	
	mov	   ebx,dword ptr [ebp-8]
   ;	
   ;	      lea   esi,[esi+ebx*NBYTE]
   ;	
	lea	   esi,[esi+ebx*(4)]
   ;	
   ;	      mov   ecx,anDigit
   ;	
	mov	   ecx,dword ptr [ebp-4]
   ;	
   ;	      sub   ecx,ebx
   ;	
	sub	   ecx,ebx
   ;	
   ;	    }
   ;	NonZero1
   ;	    __asm {
   ;	      mov   dword ptr [s2].nDigit,ecx
   ;	
	mov	   dword ptr [ebp-32+4],ecx
   ;	
   ;	      dec   ecx
   ;	
	dec	   ecx
   ;	
   ;	    }
   ;	Shift1
   ;	    __asm {
   ;	      mov   eax,dword ptr [ecx*NBYTE+esi]
   ;	
@10
	mov	   eax,dword ptr [ecx*(4)+esi]
   ;	
   ;	      mov   dword ptr [ecx*NBYTE+edi],eax
   ;	
	mov	   dword ptr [ecx*(4)+edi],eax
   ;	
   ;	      dec   ecx
   ;	
	dec	   ecx
   ;	
   ;	      jns   Shift1
   ;	
	jns       short @10
   ;	
   ;	    }
   ;	
   ;	    ab.isAdd(s2,a) ;           // ab=a2+a1
   ;	
	push      dword ptr [ebp+12]
	lea       eax,[ebp-32]
	push      eax
	lea       edx,[ebp-64]
	push      edx
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
   ;	
   ;	    s2.isSquare(s2) ;          // s2=a2^2
   ;	
	lea       ecx, [ebp-32]
	push      ecx
	lea       eax,[ebp-32]
	push      eax
	call      @Mint@isSquare$qrx4Mint
	add       esp,8
   ;	
   ;	    s1.isSquare(a) ;           // s1=a1^2
   ;	
	lea       edx,[ebp-48]
	push      dword ptr [ebp+12]
	push      edx
	call      @Mint@isSquare$qrx4Mint
	add       esp,8
   ;	
   ;	    __asm {
   ;	      mov ebx,a
   ;	
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	      mov ecx,anDigit
   ;	
	mov	 ecx,dword ptr [ebp-4]
   ;	
   ;	#ifdef __BCC__
   ;	      mov dword ptr [ebx].nDigit,ecx
   ;	#else
   ;	      mov dword ptr [ebx+NDIGIT],ecx
   ;	
	mov	 dword ptr [ebx+4],ecx
   ;	
   ;	#endif
   ;	    }
   ;	
   ;	    ab.isSquare(ab) ;          // ab=a2+a1
   ;	
	lea       ecx, [ebp-64]
	push      ecx
	lea       eax,[ebp-64]
	push      eax
	call      @Mint@isSquare$qrx4Mint
	add       esp,8
   ;	
   ;	    (ab.isSub(ab,s2)).isSub(ab,s1) ;
   ;	
	lea       edx,[ebp-48]
	lea       ecx,[ebp-64]
	lea       eax, [ebp-32]
	push      edx
	push      ecx
	push      eax
	lea       edx, [ebp-64]
	push      edx
	lea       ecx,[ebp-64]
	push      ecx
	call      @Mint@isSub$qrx4Mintt1
	add       esp,12
	push      eax
	call      @Mint@isSub$qrx4Mintt1
   ;	
   ;	    Swap(*this,s2[2*n]) ;      // *this=s2[2*n]
   ;	
	mov       eax,dword ptr [ebp-8]
	add       esp,12
	add       eax,eax
	lea       edx, [ebp-32]
	mov       dword ptr [ebp-12],eax
	lea       ecx, [ebp-32]
	push      dword ptr [ebp-12]
	push      edx
	push      ecx
	call      @Mint@isShift32$qrx4Mintxl
	add       esp,12
	push      eax
	push      dword ptr [ebp+8]
	call      @Swap$qr4Mintt1
	add       esp,8
   ;	
   ;	    isAdd(*this,ab[n]) ;
   ;	
	mov       eax,dword ptr [ebp-8]
	mov       dword ptr [ebp-16],eax
	lea       edx, [ebp-64]
	push      dword ptr [ebp-16]
	push      edx
	lea       ecx, [ebp-64]
	push      ecx
	call      @Mint@isShift32$qrx4Mintxl
	add       esp,12
	push      eax
	push      dword ptr [ebp+8]
	push      dword ptr [ebp+8]
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	check(__FILE__,__LINE__) ;
   ;	#endif
   ;	
   ;	    return isAdd(*this,s1) ;
   ;	
	lea       eax, [ebp-48]
	push      eax
	push      dword ptr [ebp+8]
	push      dword ptr [ebp+8]
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
	push      eax
	push      dword ptr [ebp-64]
	call      @$bdla$qpv
	pop       ecx
	push      dword ptr [ebp-48]
	call      @$bdla$qpv
	pop       ecx
	push      dword ptr [ebp-32]
	call      @$bdla$qpv
	pop       ecx
	pop       eax
	jmp       short @3
   ;	
   ;	  }
   ;	
@11
	jmp       short @12
   ;	
   ;	  else {
   ;	#ifdef _MEMMAN_DEBUG
   ;	check(__FILE__,__LINE__) ;
   ;	#endif
   ;	    return isMul(a,a) ;
   ;	
@5
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+8]
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
   ;	
   ;	  }
   ;	
   ;	}
   ;	
@12
@13
@3
	pop       edi
	pop       esi
	pop       ebx
	mov       esp,ebp
	pop       ebp
	ret 
