//
//  data structure for PPMPQS Ver 2.70
//
//  Copyright (C) by S.Tomabechi 2000
//     All rights reserved.
//
#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif


#ifndef __PPMPQS_HPP
#define __PPMPQS_HPP

#ifndef SIQS
struct PPrimes  {
  unsigned short diff ;        // difference of primes
  char logP ;                  // log of prime
  char dmy ;                   // adjust boundary
  unsigned long Root ;         //  square root of N mod prime
  unsigned long SievePos[2] ;  // index at which number is divisible by prime
} ;

#else
#define MAX_COMB  20
typedef struct PPrimes  {
  unsigned short diff ;        // difference of primes
  char logP ;                  // log of prime
  char dmy ;                   // adjust boundary
  unsigned long Root ;         //  square root of N mod prime
  unsigned long SievePos[2] ;  // index at which number is divisible by prime
  unsigned long ainv ;
} PPrimes ;
#endif
#endif


