//
//  Copyright (C) by S.Tomabechi 1993,1995
//  All rights reserved.
//
//  real / complex
//
#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Complex.hpp"

Complex& Complex::isDivF(const Mint& s,const Complex& c)
{
  Fint r,d ;
  if( abs(real(c))>abs(imag(c)) ) {
    if( imag(c).isZero() ) {
      re.isDivF(s,real(c)) ;
      im=0 ;
    }
    else {
      r.isDivF(real(c),imag(c)) ;
      d.isMul(r,real(c)) ;
      d.isAdd(d,imag(c)) ;

      (re.isMul(r,s)).isDivF(re,d) ;

      ~im.isDivF(s,d) ;
    }
  }
  else {
    if( real(c).isZero() ) {
      re=0 ;
      ~im.isDivF(s,imag(c)) ;
    }
    else {
      r.isDivF(imag(c),real(c)) ;
      d.isMul(r,imag(c)) ;
      d.isAdd(d,real(c)) ;
      re.isDivF(s,d) ;
      (im.isMul(r,s)).isDivF(im,d) ;
      ~im ;
    }
  }
  return *this ;
}
