%include "mint.inc"
[BITS 32]
	extrn	@$bdla$qpv
	extrn	@FFT@fft_mul$qrx4Mintt1r4Mint
	extrn	@Mint@$bctr$qii
	extrn	@Mint@$basg$qrx4Mint
	extrn	@Mint@isAdd$qrx4Mintt1
	extrn	@Mint@isSub$qrx4Mintt1
	public	@Mint@isMul$qrx4Mintt1
	extrn	@Mint@isShift32$qrx4Mintxl
	extrn	@Mint@allocate$qi
	extrn	@Mint@Karatsuba_digit
	extrn	@Mint@FFT_digit
	extrn	@Mint@_uMtemp
	extrn	@Mint@_vMtemp
	extrn	@Mint@_fft
	extrn	@Swap$qr4Mintt1
[SECTION .bss]
	align	4
_k
	resd 1	
	align	4
_l
	resd 1
[SECTION .text]
@Mint@isMul$qrx4Mintt1
   ;	
   ;	Mint& MintisMul(const Mint& a,const Mint& b)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-136
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	#ifdef _MEMMAN_DEBUG
   ;	a.check(__FILE__,__LINE__) ;
   ;	b.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	  int bnDigit ;
   ;	  int anDigit ;
   ;	
   ;	              // a=0 or b=0 ?
   ;	  __asm {
   ;	    mov  esi,a
   ;	
@1
	mov	  esi,dword ptr [ebp+12]
   ;	
   ;	    mov  edi,b
   ;	
	mov	  edi,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BCC__
   ;	    mov  eax,dword ptr [esi].nDigit
   ;	    mov  ebx,dword ptr [edi].nDigit
   ;	#else
   ;	    mov  eax,dword ptr [esi+NDIGIT]
   ;	
	mov	  eax,dword ptr [esi+4]
   ;	
   ;	    mov  ebx,dword ptr [edi+NDIGIT]
   ;	
	mov	  ebx,dword ptr [edi+4]
   ;	
   ;	#endif
   ;	    or   eax,eax
   ;	
	or	   eax,eax
   ;	
   ;	    jz   MultiplyZero
   ;	
	je        short @2
   ;	
   ;	  }
   ;	Check_b
   ;	   __asm {
   ;	    or  ebx,ebx
   ;	
	or	  ebx,ebx
   ;	
   ;	    jz  MultiplyZero
   ;	
	je        short @2
   ;	
   ;	    cmp  eax,ebx
   ;	
	cmp	  eax,ebx
   ;	
   ;	    jae  not_Swap_a_b
   ;	
	jae       short @3
   ;	
   ;	    xchg eax,ebx
   ;	
	xchg	 eax,ebx
   ;	
   ;	    mov  a,edi
   ;	
	mov	  dword ptr [ebp+12],edi
   ;	
   ;	    mov  b,esi
   ;	
	mov	  dword ptr [ebp+16],esi
   ;	
   ;	  }
   ;	not_Swap_a_b
   ;	  __asm {
   ;	    mov  anDigit,eax
   ;	
@3
	mov	  dword ptr [ebp-8],eax
   ;	
   ;	    mov  bnDigit,ebx
   ;	
	mov	  dword ptr [ebp-4],ebx
   ;	
   ;	    jmp  Multiply0
   ;	
	jmp       short @4
   ;	
   ;	  }
   ;	MultiplyZero     // {a|>=|b|
   ;	  __asm {
   ;	    mov edi,this
   ;	
@2
	mov	 edi,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BCC__
   ;	    mov  dword ptr [edi].nDigit,0
   ;	    mov  byte ptr [edi].nDim[3],1
   ;	#else
   ;	    mov  dword ptr [edi+NDIGIT],0
   ;	
	mov	  dword ptr [edi+4],0
   ;	
   ;	    mov  byte ptr [edi+SIGN],1
   ;	
	mov	  byte ptr [edi+15],1
   ;	
   ;	#endif
   ;	    jmp  RET1
   ;	
	jmp       @5
   ;	
   ;	  }
   ;	
   ;	Multiply0 ;
   ;	              // multiplication of large integers by Karatsuba's method
   ;	  if( bnDigit>Karatsuba_digit ) {
   ;	
@4
	mov       eax,dword ptr [ebp-4]
	mov       edx,dword ptr [@Mint@Karatsuba_digit]
	cmp       eax,edx
;	jle       @7
	jg		@99_7
	jmp		@7
@99_7	
   ;	
   ;	
   ;	    long n ;
   ;	             // multiplication by Fast Fourier Transformation
   ;	    if( bnDigit>FFT_digit ) {
   ;	
@6
@8
	mov       ecx,dword ptr [ebp-4]
	mov       eax,dword ptr [@Mint@FFT_digit]
	cmp       ecx,eax
;	jle       @9
	jg 			@99_9
	jmp			@9
@99_9	
   ;	
   ;	      if( anDigit/bnDigit<2 ) {    // 礭·
   ;	
	mov       eax,dword ptr [ebp-8]
	cdq
	idiv      dword ptr [ebp-4]
	cmp       eax,2
;	jge       @10
	jl		@99_10
	jmp		@10
@99_10
   ;	
   ;		    n=anDigit ;
   ;	
	mov       ecx,dword ptr [ebp-8]
   ;	
   ;	        k=1 ;
   ;	        l=0 ;
   ;	
	xor       eax,eax
	mov       dword ptr [_k],1
	mov       dword ptr [_l],eax
	mov       dword ptr [ebp-12],ecx
	jmp       short @12
   ;	
   ;	        while( n>k ) { k<<=1 ; l++ ; }     // index such that 2^k>=n
   ;	
@11
	shl       dword ptr [_k],1
	inc       dword ptr [_l]
@12
	mov       edx,dword ptr [ebp-12]
	mov       ecx,dword ptr [_k]
	cmp       edx,ecx
	jg        short @11
   ;	
   ;	                                 // 礭ȤȾʬʬ
   ;	
   ;	//        if( (k-n)>(n-k/2) ) {
   ;	        if( 4*k>5*n ) {
   ;	
	mov       edx,dword ptr [ebp-12]
	mov       eax,dword ptr [_k]
	shl       eax,2
	lea       edx,[edx+4*edx]
	cmp       eax,edx
	jle       short @13
   ;	
   ;	//cout << " k " << hex << k << " " << n << dec ;
   ;	          n=k>>1 ;
   ;	
	mov       ecx,dword ptr [_k]
	sar       ecx,1
	mov       dword ptr [ebp-12],ecx
   ;	
   ;	          n-- ;
   ;	
	dec       dword ptr [ebp-12]
   ;	
   ;	          goto KaraTsuba ;
   ;	
	jmp       short @14
   ;	
   ;	        }
   ;	        if( l<NUM_OF_FFT_SCHEME+_FFT_BIT_ ) {
   ;	
@13
	mov       eax,dword ptr [_l]
	cmp       eax,31
	jge       short @15
   ;	
   ;	          _fft[l-_FFT_BIT_].fft_mul(a,b,*this) ;
   ;	
	push      dword ptr [ebp+8]
	push      dword ptr [ebp+16]
	push      dword ptr [ebp+12]
	mov       edx,dword ptr [_l]
	shl       edx,6
	add       edx,offset @Mint@_fft-704
	push      edx
	call      @FFT@fft_mul$qrx4Mintt1r4Mint
	add       esp,16
   ;	
   ;	          return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
	jmp       @16
   ;	
   ;	        }
   ;	      }
   ;	    }
   ;	    k=n=anDigit ;
   ;	
@15
@10
@9
	mov       edx,dword ptr [ebp-8]
	mov       dword ptr [ebp-12],edx
	mov       dword ptr [_k],edx
   ;	
   ;	    n>>=1 ;
   ;	
	sar       dword ptr [ebp-12],1
   ;	
   ;	
   ;	/**********
   ;	    __asm {
   ;	      mov  eax,n               // eax <- n
   ;	      test eax,1               // even ?
   ;	      jz   POW2
   ;	      inc  eax
   ;	    }
   ;	POW2
   ;	  __asm {
   ;	      mov edx,eax             // save n
   ;	      bsr ecx,eax
   ;	      xor ebx,ebx
   ;	      inc ebx
   ;	      shl ebx,cl              // the least power of 2 ebx=2^k s.t. ebx>n
   ;	
   ;	      xor edx,ebx
   ;	      jz  SET_n               // n is power of 2
   ;	      shl ebx,1
   ;	    }
   ;	SET_n
   ;	  __asm {
   ;	      mov n,ebx
   ;	    }
   ;	    n>>=1 ;
   ;	//    n-- ;
   ;	*****************/
   ;	KaraTsuba
   ;	/*************
   ;	    if( n&1 ) n++ ;
   ;	    k=n ;
   ;	    l=1 ;
   ;	    while( n!=1 ) {
   ;	      n>>=1 ;
   ;	      l<<=1 ;
   ;	    }
   ;	    n=l ;
   ;	    k^=n ;
   ;	    if( k==0 ) ;
   ;	    else n<<=1 ;
   ;	***********/
   ;	                 // Ĥʬʬ
   ;	                 // a=a1*t+a0        t=(2^32)^n
   ;	                 // b=b1*t+b0
   ;	                 // a*b=p2*t^2+p1*t+p0
   ;	                 // p2=a1*b1 p0=a0*b0
   ;	                 // p1=(a1+a0)*(b1+b0)-p2-p0
   ;	    Mint p2(k,0),
   ;	
@14
	push      dword 0
	lea       eax,[ebp-72]
	push      dword ptr [_k]
	push      eax
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	         p1(k,0),
   ;	
	lea       ecx,[ebp-88]
	push      dword 0
	push      dword ptr [_k]
	push      ecx
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	         p0(k,0) ;
   ;	
	lea       eax,[ebp-104]
	push      dword 0
	push      dword ptr [_k]
	push      eax
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	    Mint a1(n,0) ;
   ;	
	lea       edx,[ebp-120]
	push      dword 0
	push      dword ptr [ebp-12]
	push      edx
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	    __asm {               // Ĵ
   ;	                          // δؿǤϷ exact ǤʤȰʤΤ
   ;	                          // Ĵ
   ;	       mov  esi,a
   ;	
	mov	  esi,dword ptr [ebp+12]
   ;	
   ;	       mov  ebx,n
   ;	
	mov	  ebx,dword ptr [ebp-12]
   ;	
   ;	#ifdef __BCC__
   ;	       mov  edi,dword ptr [esi].digit
   ;	#else
   ;	       mov  edi,dword ptr [esi+DIGIT]
   ;	
	mov	  edi,dword ptr [esi+0]
   ;	
   ;	#endif
   ;	       cmp   anDigit,ebx
   ;	
	cmp	   dword ptr [ebp-8],ebx
   ;	
   ;	       jae   SearchZero1
   ;	
	jae       short @17
   ;	
   ;	       mov   ebx,anDigit  // case a<t
   ;	
	mov	   ebx,dword ptr [ebp-8]  
   ;	
   ;	    }
   ;	SearchZero1
   ;	    __asm {
   ;	       cmp  dword ptr [ebx*NBYTE+edi-NBYTE],0
   ;	
@17
	cmp	  dword ptr [ebx*(4)+edi-(4)],0
   ;	
   ;	       jne  FindNonZero1
   ;	
	jne       short @18
   ;	
   ;	       dec  ebx
   ;	
	dec	  ebx
   ;	
   ;	       jnz  SearchZero1
   ;	
	jne       short @17
   ;	
   ;	    }
   ;	FindNonZero1
   ;	    __asm {
   ;	#ifdef __BCC__
   ;	      mov   dword ptr [esi].nDigit,ebx
   ;	#else
   ;	      mov   dword ptr [esi+NDIGIT],ebx
   ;	
@18
	mov	   dword ptr [esi+4],ebx
   ;	
   ;	#endif
   ;	      mov   edi,dword ptr [a1].digit
   ;	
	mov	   edi,dword ptr [ebp-120]
   ;	
   ;	
   ;	      mov   esi,a        // 98/01/11
   ;	
	mov	   esi,dword ptr [ebp+12]        
   ;	
   ;	#ifdef __BCC__
   ;	      mov   bl,byte ptr [esi].nDim[3]
   ;	      mov   byte ptr [a1].nDim[3],bl
   ;	      mov   esi,dword ptr [esi].digit
   ;	#else
   ;	      mov   bl,byte ptr [esi+SIGN]
   ;	
	mov	   bl,byte ptr [esi+15]
   ;	
   ;	      mov   byte ptr [a1+SIGN],bl
   ;	
	mov	   byte ptr [ebp-120+15],bl
   ;	
   ;	      mov   esi,dword ptr [esi+DIGIT]
   ;	
	mov	   esi,dword ptr [esi]
   ;	
   ;	#endif
   ;	
   ;	      mov   ebx,n
   ;	
	mov	   ebx,dword ptr [ebp-12]
   ;	
   ;	      lea   esi,[esi+ebx*NBYTE]
   ;	
	lea	   esi,[esi+ebx*(4)]
   ;	
   ;	      mov   ecx,anDigit
   ;	
	mov	   ecx,dword ptr [ebp-8]
   ;	
   ;	      sub   ecx,ebx
   ;	
	sub	   ecx,ebx
   ;	
   ;	      ja    NonZero1
   ;	
	ja        short @19
   ;	
   ;	#ifdef __BCC__
   ;	      mov   dword ptr [a1].nDigit,0      // =0
   ;	      mov   byte ptr [a1].nDim[3],1
   ;	#else
   ;	      mov   dword ptr [a1+NDIGIT],0
   ;	
	mov	   dword ptr [ebp-120+4],0
   ;	
   ;	      mov   byte ptr [a1+SIGN],1
   ;	
	mov	   byte ptr [ebp-120+15],1
   ;	
   ;	#endif
   ;	      jmp   KaraMul1
   ;	
	jmp       short @20
   ;	
   ;	    }
   ;	NonZero1
   ;	     __asm {
   ;	#ifdef __BCC__
   ;	      mov   dword ptr [a1].nDigit,ecx
   ;	#else
   ;	      mov   dword ptr [a1+NDIGIT],ecx
   ;	
@19
	mov	   dword ptr [ebp-120+4],ecx
   ;	
   ;	#endif
   ;	      dec   ecx
   ;	
	dec	   ecx
   ;	
   ;	    }
   ;	Shift1
   ;	    __asm {
   ;	      mov   eax,dword ptr [ecx*NBYTE+esi]
   ;	
@21
	mov	   eax,dword ptr [ecx*(4)+esi]
   ;	
   ;	      mov   dword ptr [ecx*NBYTE+edi],eax
   ;	
	mov	   dword ptr [ecx*(4)+edi],eax
   ;	
   ;	      dec   ecx
   ;	
	dec	   ecx
   ;	
   ;	      jns   Shift1
   ;	
	jns       short @21
   ;	
   ;	    }
   ;	
   ;	KaraMul1
   ;	    if( &a==&b ) {
   ;	
@20
	mov       ecx,dword ptr [ebp+12]
	mov       eax,dword ptr [ebp+16]
	cmp       ecx,eax
	jne       short @22
   ;	
   ;	       p2.isMul(a1,a1) ;      // p2=a1^2
   ;	
	lea       edx,[ebp-120]
	push      edx
	lea       ecx,[ebp-120]
	push      ecx
	lea       eax,[ebp-72]
	push      eax
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
   ;	
   ;	       a1.isAdd(a1,a) ;       // a1=a1+a0
   ;	
	lea       edx,[ebp-120]
	lea       ecx,[ebp-120]
	push      dword ptr [ebp+12]
	push      edx
	push      ecx
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
   ;	
   ;	       p1.isMul(a1,a1) ;      // (a1+a0)^2
   ;	
	lea       eax,[ebp-120]
	lea       edx,[ebp-120]
	lea       ecx,[ebp-88]
	push      eax
	push      edx
	push      ecx
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
   ;	
   ;	       p0.isMul(a,a) ;
   ;	
	lea       eax,[ebp-104]
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+12]
	push      eax
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
   ;	
   ;	    }
   ;	
	jmp       @23
   ;	
   ;	    else {
   ;	      Mint b1(n,0) ;
   ;	
@22
@24
	push      dword 0
	lea       edx,[ebp-136]
	push      dword ptr [ebp-12]
	push      edx
	call      @Mint@$bctr$qii
	add       esp,12
   ;	
   ;	      __asm {
   ;	         mov   esi,b
   ;	
	mov	   esi,dword ptr [ebp+16]
   ;	
   ;	         mov   ebx,n
   ;	
	mov	   ebx,dword ptr [ebp-12]
   ;	
   ;	#ifdef __BCC__
   ;	         mov   edi,dword ptr [esi].digit
   ;	#else
   ;	         mov   edi,dword ptr [esi+DIGIT]
   ;	
	mov	   edi,dword ptr [esi+0]
   ;	
   ;	#endif
   ;	         cmp   bnDigit,ebx
   ;	
	cmp	   dword ptr [ebp-4],ebx
   ;	
   ;	         jae   SearchZero2
   ;	
	jae       short @25
   ;	
   ;	         mov   ebx,bnDigit       // case b<t
   ;	
	mov	   ebx,dword ptr [ebp-4]       
   ;	
   ;	       }
   ;	SearchZero2
   ;	      __asm {
   ;	         cmp   dword ptr [ebx*NBYTE+edi-NBYTE],0
   ;	
@25
	cmp	   dword ptr [ebx*(4)+edi-(4)],0
   ;	
   ;	         jne   FindNonZero2
   ;	
	jne       short @26
   ;	
   ;	         dec   ebx
   ;	
	dec	   ebx
   ;	
   ;	         jnz   SearchZero2
   ;	
	jne       short @25
   ;	
   ;	      }
   ;	FindNonZero2
   ;	      __asm {
   ;	#ifdef __BCC__
   ;	        mov   dword ptr [esi].nDigit,ebx
   ;	        mov   edi,dword ptr [b1].digit
   ;	#else
   ;	        mov   dword ptr [esi+NDIGIT],ebx
   ;	
@26
	mov	   dword ptr [esi+4],ebx
   ;	
   ;	        mov   edi,dword ptr [b1+DIGIT]
   ;	
	mov	   edi,dword ptr [ebp-136]
   ;	
   ;	#endif
   ;	        mov   esi,b
   ;	
	mov	   esi,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BCC__
   ;	        mov   bl,byte ptr [esi].nDim[3]
   ;	        mov   byte ptr [b1].nDim[3],bl
   ;	        mov   esi,dword ptr [esi].digit
   ;	#else
   ;	        mov   bl,byte ptr [esi+SIGN]
   ;	
	mov	   bl,byte ptr [esi+15]
   ;	
   ;	        mov   byte ptr [b1+SIGN],bl
   ;	
	mov	   byte ptr [ebp-136+15],bl
   ;	
   ;	        mov   esi,dword ptr [esi+DIGIT]
   ;	
	mov	   esi,dword ptr [esi]
   ;	
   ;	#endif
   ;	
   ;	        mov   ebx,n
   ;	
	mov	   ebx,dword ptr [ebp-12]
   ;	
   ;	        lea   esi,[esi+ebx*NBYTE]
   ;	
	lea	   esi,[esi+ebx*(4)]
   ;	
   ;	        mov   ecx,bnDigit
   ;	
	mov	   ecx,dword ptr [ebp-4]
   ;	
   ;	        sub   ecx,ebx
   ;	
	sub	   ecx,ebx
   ;	
   ;	        ja    NonZero2
   ;	
	ja        short @27
   ;	
   ;	#ifdef __BCC__
   ;	        mov   dword ptr [b1].nDigit,0
   ;	        mov   byte ptr [b1].nDim[3],1
   ;	#else
   ;	        mov   dword ptr [b1+NDIGIT],0
   ;	
	mov	   dword ptr [ebp-136+4],0
   ;	
   ;	        mov   byte ptr [b1+SIGN],1
   ;	
	mov	   byte ptr [ebp-136+15],1
   ;	
   ;	#endif
   ;	        jmp   KaraMul2
   ;	
	jmp       short @28
   ;	
   ;	      }
   ;	NonZero2
   ;	      __asm {
   ;	#ifdef __BCC__
   ;	        mov   dword ptr [b1].nDigit,ecx
   ;	#else
   ;	        mov   dword ptr [b1+NDIGIT],ecx
   ;	
@27
	mov	   dword ptr [ebp-136+4],ecx
   ;	
   ;	#endif
   ;	        dec   ecx
   ;	
	dec	   ecx
   ;	
   ;	      }
   ;	Shift2
   ;	    __asm {
   ;	        mov   eax,dword ptr [ecx*NBYTE+esi]
   ;	
@29
	mov	   eax,dword ptr [ecx*(4)+esi]
   ;	
   ;	        mov   dword ptr [ecx*NBYTE+edi],eax
   ;	
	mov	   dword ptr [ecx*(4)+edi],eax
   ;	
   ;	        dec   ecx
   ;	
	dec	   ecx
   ;	
   ;	        jns   Shift2
   ;	
	jns       short @29
   ;	
   ;	      }
   ;	
   ;	KaraMul2
   ;	      p2.isMul(a1,b1) ;
   ;	
@28
	lea       ecx,[ebp-136]
	push      ecx
	lea       eax,[ebp-120]
	push      eax
	lea       edx,[ebp-72]
	push      edx
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
   ;	
   ;	      p1.isMul(a1+=a,b1+=b ) ;
   ;	
	mov       ecx,dword ptr [ebp+16]
	mov       dword ptr [ebp-20],ecx
	lea       eax,[ebp-136]
	push      dword ptr [ebp-20]
	push      eax
	lea       edx,[ebp-136]
	push      edx
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
	lea       edx,[ebp-120]
	push      eax
	lea       eax,[ebp-120]
	mov       ecx,dword ptr [ebp+12]
	mov       dword ptr [ebp-16],ecx
	push      dword ptr [ebp-16]
	push      eax
	push      edx
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
	push      eax
	lea       ecx,[ebp-88]
	push      ecx
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
   ;	
   ;	      p0.isMul(a,b) ;
   ;	
	lea       eax,[ebp-104]
	push      dword ptr [ebp+16]
	push      dword ptr [ebp+12]
	push      eax
	call      @Mint@isMul$qrx4Mintt1
	add       esp,12
   ;	
   ;	      __asm {
   ;	        mov   eax,b
   ;	
	mov	   eax,dword ptr [ebp+16]
   ;	
   ;	        mov   ecx,bnDigit
   ;	
	mov	   ecx,dword ptr [ebp-4]
   ;	
   ;	#ifdef __BCC__
   ;	        mov   dword ptr [eax].nDigit,ecx     // Ȥη᤹
   ;	#else
   ;	        mov   dword ptr [eax+NDIGIT],ecx
   ;	
	mov	   dword ptr [eax+4],ecx
   ;	
   ;	#endif
   ;	      }
   ;	    }
   ;	
	push      dword ptr [ebp-136]
	call      @$bdla$qpv
	pop       ecx
   ;	
   ;	    __asm {
   ;	       mov   eax,a
   ;	
@30
@23
	mov	   eax,dword ptr [ebp+12]
   ;	
   ;	       mov   ecx,anDigit
   ;	
	mov	   ecx,dword ptr [ebp-8]
   ;	
   ;	#ifdef __BCC__
   ;	       mov   dword ptr [eax].nDigit,ecx
   ;	#else
   ;	       mov   dword ptr [eax+NDIGIT],ecx
   ;	
	mov	   dword ptr [eax+4],ecx
   ;	
   ;	#endif
   ;	    }
   ;	
   ;	    (p1.isSub(p1,p2)).isSub(p1,p0) ;   // p1=p1-p2-p0
   ;	
	lea       edx,[ebp-104]
	push      edx
	lea       ecx,[ebp-88]
	push      ecx
	lea       eax,[ebp-72]
	push      eax
	lea       edx,[ebp-88]
	push      edx
	lea       ecx,[ebp-88]
	push      ecx
	call      @Mint@isSub$qrx4Mintt1
	add       esp,12
	push      eax
	call      @Mint@isSub$qrx4Mintt1
   ;	
   ;	
   ;	    Swap(*this,p2[2*n]) ;  // ꡢ򴹤®
   ;	
	mov       eax,dword ptr [ebp-12]
	add       esp,12
	add       eax,eax
	lea       edx,[ebp-72]
	mov       dword ptr [ebp-24],eax
	lea       ecx,[ebp-72]
	push      dword ptr [ebp-24]
	push      edx
	push      ecx
	call      @Mint@isShift32$qrx4Mintxl
	add       esp,12
	push      eax
	push      dword ptr [ebp+8]
	call      @Swap$qr4Mintt1
	add       esp,8
   ;	
   ;	
   ;	    isAdd(*this,p1[n]) ;
   ;	
	mov       eax,dword ptr [ebp-12]
	mov       dword ptr [ebp-28],eax
	lea       edx,[ebp-88]
	push      dword ptr [ebp-28]
	push      edx
	lea       ecx,[ebp-88]
	push      ecx
	call      @Mint@isShift32$qrx4Mintxl
	add       esp,12
	push      eax
	push      dword ptr [ebp+8]
	push      dword ptr [ebp+8]
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	_MemMan.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	    return isAdd(*this,p0) ;
   ;	
	lea       eax,[ebp-104]
	push      eax
	push      dword ptr [ebp+8]
	push      dword ptr [ebp+8]
	call      @Mint@isAdd$qrx4Mintt1
	add       esp,12
	push      eax
	push      dword ptr [ebp-120]
	call      @$bdla$qpv
	pop       ecx
	push      dword ptr [ebp-104]
	call      @$bdla$qpv
	pop       ecx
	push      dword ptr [ebp-88]
	call      @$bdla$qpv
	pop       ecx
	push      dword ptr [ebp-72]
	call      @$bdla$qpv
	pop       ecx
	pop       eax
	jmp       @16
   ;	
   ;	  }
   ;	
   ;	  int abnDigit(anDigit+bnDigit) ; // Ѥκ
   ;	
@31
@7
	mov       edx,dword ptr [ebp-8]
	mov       ecx,dword ptr [ebp-4]
	add       edx,ecx
	mov       dword ptr [ebp-32],edx
   ;	
   ;	  int Count ;
   ;	  unsigned long bi ;
   ;	  unsigned long* pa ;
   ;	  unsigned long* pb ;
   ;	  unsigned long Carry ;
   ;	  signed char this_sign ;
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	_MemMan.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	
   ;	  if( this==&a ) {         // copy a
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [ebp+12]
	cmp       eax,edx
	jne       short @32
   ;	
   ;	    _uMtemp=a ;
   ;	
	push      dword ptr [ebp+12]
	push      offset dword @Mint@_uMtemp
	call      @Mint@$basg$qrx4Mint
	add       esp,8
   ;	
   ;	    pa=_uMtemp.digit ;
   ;	
	mov       ecx,dword ptr [@Mint@_uMtemp]
	mov       dword ptr [ebp-44],ecx
   ;	
   ;	  }
   ;	
	jmp       short @33
   ;	
   ;	  else pa=a.digit ;
   ;	
@32
	mov       eax,dword ptr [ebp+12]
	mov       edx,dword ptr [eax]
	mov       dword ptr [ebp-44],edx
   ;	
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	_MemMan.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	
   ;	  if( this==&b ) {         // copy b
   ;	
@33
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ebp+16]
	cmp       ecx,eax
	jne       short @34
   ;	
   ;	    if( this!=&a ) { _vMtemp=b ; pb=_vMtemp.digit ; }
   ;	
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [ebp+12]
	cmp       edx,ecx
	je        short @35
	push      dword ptr [ebp+16]
	push      offset dword @Mint@_vMtemp
	call      @Mint@$basg$qrx4Mint
	add       esp,8
	mov       eax,dword ptr [@Mint@_vMtemp]
	mov       dword ptr [ebp-48],eax
	jmp       short @36
   ;	
   ;	    else pb=pa ;
   ;	
@35
	mov       edx,dword ptr [ebp-44]
	mov       dword ptr [ebp-48],edx
   ;	
   ;	  }
   ;	
	jmp       short @36
   ;	
   ;	  else pb=b.digit ;
   ;	
@34
	mov       ecx,dword ptr [ebp+16]
	mov       eax,dword ptr [ecx]
	mov       dword ptr [ebp-48],eax
   ;	
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	_MemMan.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	
   ;	  __asm {
   ;	    mov esi,a
   ;	
@36
	mov	 esi,dword ptr [ebp+12]
   ;	
   ;	#ifdef __BCC__
   ;	    mov al,byte ptr [esi].nDim[3]
   ;	    mov esi,b
   ;	    imul byte ptr [esi].nDim[3]
   ;	#else
   ;	    mov al,byte ptr [esi+SIGN]
   ;	
	mov	 al,byte ptr [esi+15]
   ;	
   ;	    mov esi,b
   ;	
	mov	 esi,dword ptr [ebp+16]
   ;	
   ;	    imul byte ptr [esi+SIGN]
   ;	
	imul	 byte ptr [esi+15]
   ;	
   ;	#endif
   ;	    mov this_sign,al
   ;	
	mov	 byte ptr [ebp-53],al
   ;	
   ;	  }
   ;	
   ;	  if( ndim()<=abnDigit ) allocate(abnDigit) ;  // 
   ;	
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx+12]
	and       ecx,16777215
	mov       eax,dword ptr [ebp-32]
	cmp       ecx,eax
	jg        short @37
	push      dword ptr [ebp-32]
	push      dword ptr [ebp+8]
	call      @Mint@allocate$qi
	add       esp,8
   ;	
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	_MemMan.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	
   ;	  __asm {
   ;	    mov   ebx,pb
   ;	
@37
	mov	   ebx,dword ptr [ebp-48]
   ;	
   ;	    mov   esi,pa
   ;	
	mov	   esi,dword ptr [ebp-44]
   ;	
   ;	    mov   edi,this
   ;	
	mov	   edi,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BCC__
   ;	    mov   edi,dword ptr [edi].digit
   ;	#else
   ;	    mov   edi,dword ptr [edi+DIGIT]
   ;	
	mov	   edi,dword ptr [edi+0]
   ;	
   ;	#endif
   ;	
   ;	    mov   bi,ebx        // ٤ȤΤǥǥå¸
   ;	
	mov	   dword ptr [ebp-40],ebx        
   ;	
   ;	
   ;	    mov   ecx,anDigit   // 
   ;	
	mov	   ecx,dword ptr [ebp-8]   
   ;	
   ;	    xor   eax,eax
   ;	
	xor	   eax,eax
   ;	
   ;	  }
   ;	clear                  // for( j=0 ; j<ndigit ; j++ ) digit[j]=0 ;
   ;	  __asm {               // this βη,anDigitʬ ꥢ
   ;	    mov   dword ptr [ecx*NBYTE+edi-NBYTE],eax
   ;	
@38
	mov	   dword ptr [ecx*(4)+edi-(4)],eax
   ;	
   ;	    dec   ecx
   ;	
	dec	   ecx
   ;	
   ;	    jnz   clear
   ;	
	jne       short @38
   ;	
   ;	  }
   ;	OuterLoop
   ;	  __asm {
   ;	    mov   ebx,bi
   ;	
@39
	mov	   ebx,dword ptr [ebp-40]
   ;	
   ;	    mov   ecx,dword ptr [ebx] // ecx=b.digit[j]
   ;	
	mov	   ecx,dword ptr [ebx] 
   ;	
   ;	  }
   ;	                        // b.digit[j] != 0 ξ
   ;	InnerLoop              // b.digit[j]*this ׻
   ;	  __asm {               // ebx=b.digit[j] ϤΥ-פǤ
   ;	    mov   edx,anDigit   // η
   ;	
	mov	   edx,dword ptr [ebp-8]   
   ;	
   ;	    mov   Count,edx     // 롼ץ
   ;	
	mov	   dword ptr [ebp-36],edx     
   ;	
   ;	    xor   ebx,ebx       // ebx ١쥸Ȥƻ
   ;	
	xor	   ebx,ebx       
   ;	
   ;	    mov   Carry,ebx
   ;	
	mov	   dword ptr [ebp-52],ebx
   ;	
   ;	  }
   ;	Multiply
   ;	  __asm {
   ;	      mov   eax,dword ptr [ebx*NBYTE+esi]
   ;	
@40
	mov	   eax,dword ptr [ebx*(4)+esi]
   ;	
   ;	      mul   ecx
   ;	
	mul	   ecx
   ;	
   ;	      add   eax,Carry   // η夫η夬
   ;	
	add	   eax,dword ptr [ebp-52]   
   ;	
   ;	      adc   edx,0       // βûǤդ줬η
   ;	
	adc	   edx,0       
   ;	
   ;	                        // βûǤդ줬뤳ȤϤʤ
   ;	      add   dword ptr [ebx*NBYTE+edi],eax
   ;	
	add	   dword ptr [ebx*(4)+edi],eax
   ;	
   ;	      adc   edx,0       // 夬ä
   ;	
	adc	   edx,0       
   ;	
   ;	      mov   Carry,edx   // դ򥻡
   ;	
	mov	   dword ptr [ebp-52],edx   
   ;	
   ;	//      adc   Carry,edx
   ;	      inc   ebx         // η
   ;	
	inc	   ebx         
   ;	
   ;	      dec   Count
   ;	
	dec	   dword ptr [ebp-36]
   ;	
   ;	      jnz   Multiply    // ٤Ƥη˾褸 ?
   ;	
	jne       @40
   ;	
   ;	      mov   dword ptr [ebx*NBYTE+edi],edx   // դ򡢾η
   ;	
	mov	   dword ptr [ebx*(4)+edi],edx   
   ;	
   ;	   }
   ;	end_InnerLoop
   ;	  __asm {
   ;	    add     bi,NBYTE    // ǥå1ʤ
   ;	
	add	     dword ptr [ebp-40],(4)    
   ;	
   ;	    lea     edi,[edi+NBYTE]
   ;	
	lea	     edi,[edi+(4)]
   ;	
   ;	    dec     bnDigit     // 롼ץ󥿤򸺤
   ;	
	dec	     dword ptr [ebp-4]     
   ;	
   ;	    jnz     OuterLoop
   ;	
	jne       @39
   ;	
   ;	   }
   ;	
   ;	CheckDigits                          // Υå
   ;	  __asm {
   ;	
   ;	    mov   edi,this
   ;	
	mov	   edi,dword ptr [ebp+8]
   ;	
   ;	    mov   al,this_sign
   ;	
	mov	   al,byte ptr [ebp-53]
   ;	
   ;	#ifdef __BCC__
   ;	    mov   esi,dword ptr [edi].digit
   ;	    mov   byte ptr [edi].nDim[3],al
   ;	#else
   ;	    mov   esi,dword ptr [edi+DIGIT]
   ;	
	mov	   esi,dword ptr [edi+0]
   ;	
   ;	    mov   byte ptr [edi+SIGN],al
   ;	
	mov	   byte ptr [edi+15],al
   ;	
   ;	#endif
   ;	    mov   ebx,abnDigit  // 
   ;	
	mov	   ebx,dword ptr [ebp-32]  
   ;	
   ;	  }
   ;	IsZero                       // search nonzero digit
   ;	  __asm {
   ;	    cmp   dword ptr [ebx*NBYTE+esi-NBYTE],0
   ;	
	cmp	   dword ptr [ebx*(4)+esi-(4)],0
   ;	
   ;	    jne   Set
   ;	
	jne       short @41
   ;	
   ;	    dec   ebx
   ;	
	dec	   ebx
   ;	
   ;	  }
   ;	Set
   ;	OK
   ;	  __asm {
   ;	#ifdef __BCC__
   ;	    mov dword ptr [edi].nDigit,ebx
   ;	#else
   ;	    mov dword ptr [edi+NDIGIT],ebx
   ;	
@41
	mov	 dword ptr [edi+4],ebx
   ;	
   ;	#endif
   ;	  }
   ;	
   ;	RET1
   ;	#ifdef _MEMMAN_DEBUG
   ;	_MemMan.check(__FILE__,__LINE__) ;
   ;	check(__FILE__,__LINE__) ;
   ;	#endif
   ;	  return *this ;
   ;	
@5
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	}
   ;	
@42
@16
	pop       edi
	pop       esi
	pop       ebx
	mov       esp,ebp
	pop       ebp
	ret 
